package com.sun.jndi.url.iiop;

import javax.naming.InvalidNameException;
import com.sun.jndi.cosnaming.IiopUrl;
import com.sun.jndi.cosnaming.CorbanameUrl;
import java.net.MalformedURLException;
import javax.naming.Name;
import javax.naming.NamingException;
import javax.naming.spi.ResolveResult;
import java.util.Hashtable;
import com.sun.jndi.toolkit.url.GenericURLContext;

public class iiopURLContext extends GenericURLContext
{
    iiopURLContext(Hashtable<?, ?> env) {
        super(env);
    }
    
    @Override
    protected ResolveResult getRootURLContext(String s, Hashtable<?, ?> hashtable) throws NamingException {
        return iiopURLContextFactory.getUsingURLIgnoreRest(s, hashtable);
    }
    
    @Override
    protected Name getURLSuffix(String s, String str) throws NamingException {
        try {
            if (str.startsWith("iiop://") || str.startsWith("iiopname://")) {
                return new IiopUrl(str).getCosName();
            }
            if (str.startsWith("corbaname:")) {
                return new CorbanameUrl(str).getCosName();
            }
            throw new MalformedURLException("Not a valid URL: " + str);
        }
        catch (MalformedURLException ex) {
            throw new InvalidNameException(ex.getMessage());
        }
    }
}
